# -*- coding: utf-8 -*-
# Generated by Django 1.11.3 on 2018-03-30 16:34
from __future__ import unicode_literals

from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Department',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200, verbose_name='Название')),
                ('address', models.CharField(blank=True, max_length=80, null=True, verbose_name='Адрес')),
            ],
        ),
        migrations.CreateModel(
            name='Employee',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('fio', models.CharField(blank=True, max_length=50, null=True, verbose_name='ФИО')),
                ('date_of_birth', models.DateField(verbose_name='Возраст')),
                ('photo', models.ImageField(blank=True, null=True, upload_to='img/', verbose_name='Фото')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='EmployeesInDepartments',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('is_director', models.BooleanField()),
                ('department', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='kpi.Department')),
                ('employee', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='kpi.Employee')),
            ],
        ),
        migrations.CreateModel(
            name='File',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('file', models.FileField(upload_to='files/', verbose_name='Файл')),
            ],
        ),
        migrations.CreateModel(
            name='Indicator',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.TextField(blank=True, null=True, verbose_name='Описание')),
                ('count', models.IntegerField(default=0, validators=[django.core.validators.MinValueValidator(0)], verbose_name='Кол-во')),
            ],
        ),
        migrations.CreateModel(
            name='IndicatorContext',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=200)),
                ('parent_department', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='indicator_contexts', to='kpi.Department')),
            ],
        ),
        migrations.CreateModel(
            name='IndicatorsForEmployees',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('count', models.IntegerField(default=0, validators=[django.core.validators.MinValueValidator(0)], verbose_name='Кол-во')),
                ('employee', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='kpi.Employee')),
                ('indicator', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='kpi.Indicator')),
            ],
        ),
        migrations.CreateModel(
            name='Report',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('done_count', models.IntegerField(default=0, validators=[django.core.validators.MinValueValidator(0)], verbose_name='Сделано')),
                ('description', models.TextField(verbose_name='Отчёт')),
                ('owner', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='reports', to='kpi.Indicator', verbose_name='Показатель')),
            ],
        ),
        migrations.CreateModel(
            name='Set',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50)),
                ('start_date', models.DateField()),
                ('end_date', models.DateField()),
            ],
        ),
        migrations.CreateModel(
            name='SetsInDepartments',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('department', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='all_sets_in_departments', to='kpi.Department')),
                ('set', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='all_sets_in_departments', to='kpi.Set')),
            ],
        ),
        migrations.AddField(
            model_name='set',
            name='all_departments',
            field=models.ManyToManyField(related_name='all_sets', through='kpi.SetsInDepartments', to='kpi.Department'),
        ),
        migrations.AddField(
            model_name='set',
            name='parent_department',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='created_sets', to='kpi.Department'),
        ),
        migrations.AddField(
            model_name='indicator',
            name='context',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='indicators', to='kpi.IndicatorContext', verbose_name='Контекст'),
        ),
        migrations.AddField(
            model_name='indicator',
            name='employees',
            field=models.ManyToManyField(related_name='indicators', through='kpi.IndicatorsForEmployees', to='kpi.Employee'),
        ),
        migrations.AddField(
            model_name='indicator',
            name='parent',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='children', to='kpi.Indicator'),
        ),
        migrations.AddField(
            model_name='indicator',
            name='set',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='kpi.SetsInDepartments'),
        ),
        migrations.AddField(
            model_name='file',
            name='report',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='files', to='kpi.Report', verbose_name='Отчёт'),
        ),
        migrations.AddField(
            model_name='department',
            name='employees',
            field=models.ManyToManyField(related_name='departments', through='kpi.EmployeesInDepartments', to='kpi.Employee', verbose_name='Сотрудники'),
        ),
        migrations.AddField(
            model_name='department',
            name='parent',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='children', to='kpi.Department'),
        ),
    ]
